# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from redrover_api import schemas  # noqa: F401


class AbsenceCreateRequest(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        required = {
            "StartDate",
            "Details",
            "Employee",
            "EndDate",
        }
        
        class properties:
            validateOnly = schemas.BoolSchema
            
            
            class externalId(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    max_length = 50
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'externalId':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def employee() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
            
            
            class notesToApprover(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    max_length = 1500
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'notesToApprover':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class adminOnlyNotes(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    max_length = 1500
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'adminOnlyNotes':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class details(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['AbsenceDetailCreateRequest']:
                        return AbsenceDetailCreateRequest
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['AbsenceDetailCreateRequest'], typing.List['AbsenceDetailCreateRequest']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'details':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'AbsenceDetailCreateRequest':
                    return super().__getitem__(i)
            startDate = schemas.DateTimeSchema
            endDate = schemas.DateTimeSchema
            
            
            class vacancies(
                schemas.ListBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneTupleMixin
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['AbsenceVacancyRequest']:
                        return AbsenceVacancyRequest
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[list, tuple, None, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'vacancies':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            __annotations__ = {
                "validateOnly": validateOnly,
                "externalId": externalId,
                "employee": employee,
                "notesToApprover": notesToApprover,
                "adminOnlyNotes": adminOnlyNotes,
                "details": details,
                "startDate": startDate,
                "endDate": endDate,
                "vacancies": vacancies,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["validateOnly"]) -> MetaOapg.properties.validateOnly: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["externalId"]) -> MetaOapg.properties.externalId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["employee"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["notesToApprover"]) -> MetaOapg.properties.notesToApprover: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["adminOnlyNotes"]) -> MetaOapg.properties.adminOnlyNotes: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["details"]) -> MetaOapg.properties.details: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["startDate"]) -> MetaOapg.properties.startDate: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["endDate"]) -> MetaOapg.properties.endDate: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["vacancies"]) -> MetaOapg.properties.vacancies: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["validateOnly"], typing_extensions.Literal["externalId"], typing_extensions.Literal["employee"], typing_extensions.Literal["notesToApprover"], typing_extensions.Literal["adminOnlyNotes"], typing_extensions.Literal["details"], typing_extensions.Literal["startDate"], typing_extensions.Literal["endDate"], typing_extensions.Literal["vacancies"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["validateOnly"]) -> typing.Union[MetaOapg.properties.validateOnly, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["externalId"]) -> typing.Union[MetaOapg.properties.externalId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["employee"]) -> typing.Union['Int32LocatorRequest', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["notesToApprover"]) -> typing.Union[MetaOapg.properties.notesToApprover, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["adminOnlyNotes"]) -> typing.Union[MetaOapg.properties.adminOnlyNotes, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["details"]) -> typing.Union[MetaOapg.properties.details, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["startDate"]) -> typing.Union[MetaOapg.properties.startDate, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["endDate"]) -> typing.Union[MetaOapg.properties.endDate, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["vacancies"]) -> typing.Union[MetaOapg.properties.vacancies, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["validateOnly"], typing_extensions.Literal["externalId"], typing_extensions.Literal["employee"], typing_extensions.Literal["notesToApprover"], typing_extensions.Literal["adminOnlyNotes"], typing_extensions.Literal["details"], typing_extensions.Literal["startDate"], typing_extensions.Literal["endDate"], typing_extensions.Literal["vacancies"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        validateOnly: typing.Union[MetaOapg.properties.validateOnly, bool, schemas.Unset] = schemas.unset,
        externalId: typing.Union[MetaOapg.properties.externalId, None, str, schemas.Unset] = schemas.unset,
        employee: typing.Union['Int32LocatorRequest', schemas.Unset] = schemas.unset,
        notesToApprover: typing.Union[MetaOapg.properties.notesToApprover, None, str, schemas.Unset] = schemas.unset,
        adminOnlyNotes: typing.Union[MetaOapg.properties.adminOnlyNotes, None, str, schemas.Unset] = schemas.unset,
        details: typing.Union[MetaOapg.properties.details, list, tuple, schemas.Unset] = schemas.unset,
        startDate: typing.Union[MetaOapg.properties.startDate, str, datetime, schemas.Unset] = schemas.unset,
        endDate: typing.Union[MetaOapg.properties.endDate, str, datetime, schemas.Unset] = schemas.unset,
        vacancies: typing.Union[MetaOapg.properties.vacancies, list, tuple, None, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'AbsenceCreateRequest':
        return super().__new__(
            cls,
            *_args,
            validateOnly=validateOnly,
            externalId=externalId,
            employee=employee,
            notesToApprover=notesToApprover,
            adminOnlyNotes=adminOnlyNotes,
            details=details,
            startDate=startDate,
            endDate=endDate,
            vacancies=vacancies,
            _configuration=_configuration,
        )

from redrover_api.model.absence_detail_create_request import AbsenceDetailCreateRequest
from redrover_api.model.absence_vacancy_request import AbsenceVacancyRequest
from redrover_api.model.int32_locator_request import Int32LocatorRequest
