# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from redrover_api import schemas  # noqa: F401


class AbsenceReasonBalanceCreateRequest(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        required = {
            "schoolYear",
        }
        
        class properties:
        
            @staticmethod
            def schoolYear() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
        
            @staticmethod
            def absenceReason() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
        
            @staticmethod
            def absenceReasonCategory() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
            
            
            class initialBalance(
                schemas.Float64Base,
                schemas.NumberBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneDecimalMixin
            ):
            
            
                class MetaOapg:
                    format = 'double'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, decimal.Decimal, int, float, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'initialBalance':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class balanceAsOf(
                schemas.DateTimeBase,
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    format = 'date-time'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, datetime, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'balanceAsOf':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def absenceReasonTrackingType() -> typing.Type['AbsenceReasonTrackingTypeEnum']:
                return AbsenceReasonTrackingTypeEnum
            __annotations__ = {
                "schoolYear": schoolYear,
                "absenceReason": absenceReason,
                "absenceReasonCategory": absenceReasonCategory,
                "initialBalance": initialBalance,
                "balanceAsOf": balanceAsOf,
                "absenceReasonTrackingType": absenceReasonTrackingType,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    schoolYear: 'Int32LocatorRequest'
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["schoolYear"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["absenceReason"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["absenceReasonCategory"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["initialBalance"]) -> MetaOapg.properties.initialBalance: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["balanceAsOf"]) -> MetaOapg.properties.balanceAsOf: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["absenceReasonTrackingType"]) -> 'AbsenceReasonTrackingTypeEnum': ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["schoolYear"], typing_extensions.Literal["absenceReason"], typing_extensions.Literal["absenceReasonCategory"], typing_extensions.Literal["initialBalance"], typing_extensions.Literal["balanceAsOf"], typing_extensions.Literal["absenceReasonTrackingType"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["schoolYear"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["absenceReason"]) -> typing.Union['Int32LocatorRequest', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["absenceReasonCategory"]) -> typing.Union['Int32LocatorRequest', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["initialBalance"]) -> typing.Union[MetaOapg.properties.initialBalance, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["balanceAsOf"]) -> typing.Union[MetaOapg.properties.balanceAsOf, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["absenceReasonTrackingType"]) -> typing.Union['AbsenceReasonTrackingTypeEnum', schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["schoolYear"], typing_extensions.Literal["absenceReason"], typing_extensions.Literal["absenceReasonCategory"], typing_extensions.Literal["initialBalance"], typing_extensions.Literal["balanceAsOf"], typing_extensions.Literal["absenceReasonTrackingType"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        schoolYear: 'Int32LocatorRequest',
        absenceReason: typing.Union['Int32LocatorRequest', schemas.Unset] = schemas.unset,
        absenceReasonCategory: typing.Union['Int32LocatorRequest', schemas.Unset] = schemas.unset,
        initialBalance: typing.Union[MetaOapg.properties.initialBalance, None, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        balanceAsOf: typing.Union[MetaOapg.properties.balanceAsOf, None, str, datetime, schemas.Unset] = schemas.unset,
        absenceReasonTrackingType: typing.Union['AbsenceReasonTrackingTypeEnum', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'AbsenceReasonBalanceCreateRequest':
        return super().__new__(
            cls,
            *_args,
            schoolYear=schoolYear,
            absenceReason=absenceReason,
            absenceReasonCategory=absenceReasonCategory,
            initialBalance=initialBalance,
            balanceAsOf=balanceAsOf,
            absenceReasonTrackingType=absenceReasonTrackingType,
            _configuration=_configuration,
        )

from redrover_api.model.absence_reason_tracking_type_enum import AbsenceReasonTrackingTypeEnum
from redrover_api.model.int32_locator_request import Int32LocatorRequest
