# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from redrover_api import schemas  # noqa: F401


class AbsenceReasonBalanceResponse(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        
        class properties:
            id = schemas.Int32Schema
            employeeId = schemas.Int32Schema
            schoolYearId = schemas.Int32Schema
            
            
            class absenceReasonId(
                schemas.Int32Base,
                schemas.IntBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneDecimalMixin
            ):
            
            
                class MetaOapg:
                    format = 'int32'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, decimal.Decimal, int, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'absenceReasonId':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class absenceReasonCategoryId(
                schemas.Int32Base,
                schemas.IntBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneDecimalMixin
            ):
            
            
                class MetaOapg:
                    format = 'int32'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, decimal.Decimal, int, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'absenceReasonCategoryId':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            balanceAsOf = schemas.DateTimeSchema
            initialBalance = schemas.Float64Schema
            usedBalance = schemas.Float64Schema
            unusedBalance = schemas.Float64Schema
            earnedBalance = schemas.Float64Schema
            netBalance = schemas.Float64Schema
            usedBalanceCalculatedAtUtc = schemas.DateTimeSchema
        
            @staticmethod
            def absenceReasonTrackingType() -> typing.Type['AbsenceReasonTrackingTypeEnum']:
                return AbsenceReasonTrackingTypeEnum
            __annotations__ = {
                "id": id,
                "employeeId": employeeId,
                "schoolYearId": schoolYearId,
                "absenceReasonId": absenceReasonId,
                "absenceReasonCategoryId": absenceReasonCategoryId,
                "balanceAsOf": balanceAsOf,
                "initialBalance": initialBalance,
                "usedBalance": usedBalance,
                "unusedBalance": unusedBalance,
                "earnedBalance": earnedBalance,
                "netBalance": netBalance,
                "usedBalanceCalculatedAtUtc": usedBalanceCalculatedAtUtc,
                "absenceReasonTrackingType": absenceReasonTrackingType,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["employeeId"]) -> MetaOapg.properties.employeeId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["schoolYearId"]) -> MetaOapg.properties.schoolYearId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["absenceReasonId"]) -> MetaOapg.properties.absenceReasonId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["absenceReasonCategoryId"]) -> MetaOapg.properties.absenceReasonCategoryId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["balanceAsOf"]) -> MetaOapg.properties.balanceAsOf: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["initialBalance"]) -> MetaOapg.properties.initialBalance: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["usedBalance"]) -> MetaOapg.properties.usedBalance: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["unusedBalance"]) -> MetaOapg.properties.unusedBalance: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["earnedBalance"]) -> MetaOapg.properties.earnedBalance: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["netBalance"]) -> MetaOapg.properties.netBalance: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["usedBalanceCalculatedAtUtc"]) -> MetaOapg.properties.usedBalanceCalculatedAtUtc: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["absenceReasonTrackingType"]) -> 'AbsenceReasonTrackingTypeEnum': ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id"], typing_extensions.Literal["employeeId"], typing_extensions.Literal["schoolYearId"], typing_extensions.Literal["absenceReasonId"], typing_extensions.Literal["absenceReasonCategoryId"], typing_extensions.Literal["balanceAsOf"], typing_extensions.Literal["initialBalance"], typing_extensions.Literal["usedBalance"], typing_extensions.Literal["unusedBalance"], typing_extensions.Literal["earnedBalance"], typing_extensions.Literal["netBalance"], typing_extensions.Literal["usedBalanceCalculatedAtUtc"], typing_extensions.Literal["absenceReasonTrackingType"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["employeeId"]) -> typing.Union[MetaOapg.properties.employeeId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["schoolYearId"]) -> typing.Union[MetaOapg.properties.schoolYearId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["absenceReasonId"]) -> typing.Union[MetaOapg.properties.absenceReasonId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["absenceReasonCategoryId"]) -> typing.Union[MetaOapg.properties.absenceReasonCategoryId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["balanceAsOf"]) -> typing.Union[MetaOapg.properties.balanceAsOf, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["initialBalance"]) -> typing.Union[MetaOapg.properties.initialBalance, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["usedBalance"]) -> typing.Union[MetaOapg.properties.usedBalance, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["unusedBalance"]) -> typing.Union[MetaOapg.properties.unusedBalance, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["earnedBalance"]) -> typing.Union[MetaOapg.properties.earnedBalance, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["netBalance"]) -> typing.Union[MetaOapg.properties.netBalance, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["usedBalanceCalculatedAtUtc"]) -> typing.Union[MetaOapg.properties.usedBalanceCalculatedAtUtc, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["absenceReasonTrackingType"]) -> typing.Union['AbsenceReasonTrackingTypeEnum', schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id"], typing_extensions.Literal["employeeId"], typing_extensions.Literal["schoolYearId"], typing_extensions.Literal["absenceReasonId"], typing_extensions.Literal["absenceReasonCategoryId"], typing_extensions.Literal["balanceAsOf"], typing_extensions.Literal["initialBalance"], typing_extensions.Literal["usedBalance"], typing_extensions.Literal["unusedBalance"], typing_extensions.Literal["earnedBalance"], typing_extensions.Literal["netBalance"], typing_extensions.Literal["usedBalanceCalculatedAtUtc"], typing_extensions.Literal["absenceReasonTrackingType"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        id: typing.Union[MetaOapg.properties.id, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        employeeId: typing.Union[MetaOapg.properties.employeeId, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        schoolYearId: typing.Union[MetaOapg.properties.schoolYearId, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        absenceReasonId: typing.Union[MetaOapg.properties.absenceReasonId, None, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        absenceReasonCategoryId: typing.Union[MetaOapg.properties.absenceReasonCategoryId, None, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        balanceAsOf: typing.Union[MetaOapg.properties.balanceAsOf, str, datetime, schemas.Unset] = schemas.unset,
        initialBalance: typing.Union[MetaOapg.properties.initialBalance, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        usedBalance: typing.Union[MetaOapg.properties.usedBalance, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        unusedBalance: typing.Union[MetaOapg.properties.unusedBalance, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        earnedBalance: typing.Union[MetaOapg.properties.earnedBalance, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        netBalance: typing.Union[MetaOapg.properties.netBalance, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        usedBalanceCalculatedAtUtc: typing.Union[MetaOapg.properties.usedBalanceCalculatedAtUtc, str, datetime, schemas.Unset] = schemas.unset,
        absenceReasonTrackingType: typing.Union['AbsenceReasonTrackingTypeEnum', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'AbsenceReasonBalanceResponse':
        return super().__new__(
            cls,
            *_args,
            id=id,
            employeeId=employeeId,
            schoolYearId=schoolYearId,
            absenceReasonId=absenceReasonId,
            absenceReasonCategoryId=absenceReasonCategoryId,
            balanceAsOf=balanceAsOf,
            initialBalance=initialBalance,
            usedBalance=usedBalance,
            unusedBalance=unusedBalance,
            earnedBalance=earnedBalance,
            netBalance=netBalance,
            usedBalanceCalculatedAtUtc=usedBalanceCalculatedAtUtc,
            absenceReasonTrackingType=absenceReasonTrackingType,
            _configuration=_configuration,
        )

from redrover_api.model.absence_reason_tracking_type_enum import AbsenceReasonTrackingTypeEnum
