# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from redrover_api import schemas  # noqa: F401


class AbsenceResponse(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Absence
    """


    class MetaOapg:
        
        class properties:
            id = schemas.Int64Schema
            
            
            class externalId(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'externalId':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            orgId = schemas.Int32Schema
            startTime = schemas.DateTimeSchema
            endTime = schemas.DateTimeSchema
            numberOfDays = schemas.Int32Schema
            isClosed = schemas.BoolSchema
            isDeleted = schemas.BoolSchema
            
            
            class approvalStatus(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'approvalStatus':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class notesToApprover(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'notesToApprover':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class adminOnlyNotes(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'adminOnlyNotes':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            totalDuration = schemas.Float64Schema
            totalDayPortion = schemas.Float64Schema
        
            @staticmethod
            def employee() -> typing.Type['OrgUserEmployeeResponse']:
                return OrgUserEmployeeResponse
            
            
            class absenceDetails(
                schemas.ListBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneTupleMixin
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['AbsenceDetailResponse']:
                        return AbsenceDetailResponse
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[list, tuple, None, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'absenceDetails':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class adminEditUrl(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'adminEditUrl':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class employeeEditUrl(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'employeeEditUrl':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class vacancies(
                schemas.ListBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneTupleMixin
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['VacancyResponse']:
                        return VacancyResponse
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[list, tuple, None, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'vacancies':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            __annotations__ = {
                "id": id,
                "externalId": externalId,
                "orgId": orgId,
                "startTime": startTime,
                "endTime": endTime,
                "numberOfDays": numberOfDays,
                "isClosed": isClosed,
                "isDeleted": isDeleted,
                "approvalStatus": approvalStatus,
                "notesToApprover": notesToApprover,
                "adminOnlyNotes": adminOnlyNotes,
                "totalDuration": totalDuration,
                "totalDayPortion": totalDayPortion,
                "employee": employee,
                "absenceDetails": absenceDetails,
                "adminEditUrl": adminEditUrl,
                "employeeEditUrl": employeeEditUrl,
                "vacancies": vacancies,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["externalId"]) -> MetaOapg.properties.externalId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["orgId"]) -> MetaOapg.properties.orgId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["startTime"]) -> MetaOapg.properties.startTime: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["endTime"]) -> MetaOapg.properties.endTime: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["numberOfDays"]) -> MetaOapg.properties.numberOfDays: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["isClosed"]) -> MetaOapg.properties.isClosed: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["isDeleted"]) -> MetaOapg.properties.isDeleted: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["approvalStatus"]) -> MetaOapg.properties.approvalStatus: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["notesToApprover"]) -> MetaOapg.properties.notesToApprover: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["adminOnlyNotes"]) -> MetaOapg.properties.adminOnlyNotes: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["totalDuration"]) -> MetaOapg.properties.totalDuration: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["totalDayPortion"]) -> MetaOapg.properties.totalDayPortion: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["employee"]) -> 'OrgUserEmployeeResponse': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["absenceDetails"]) -> MetaOapg.properties.absenceDetails: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["adminEditUrl"]) -> MetaOapg.properties.adminEditUrl: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["employeeEditUrl"]) -> MetaOapg.properties.employeeEditUrl: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["vacancies"]) -> MetaOapg.properties.vacancies: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id"], typing_extensions.Literal["externalId"], typing_extensions.Literal["orgId"], typing_extensions.Literal["startTime"], typing_extensions.Literal["endTime"], typing_extensions.Literal["numberOfDays"], typing_extensions.Literal["isClosed"], typing_extensions.Literal["isDeleted"], typing_extensions.Literal["approvalStatus"], typing_extensions.Literal["notesToApprover"], typing_extensions.Literal["adminOnlyNotes"], typing_extensions.Literal["totalDuration"], typing_extensions.Literal["totalDayPortion"], typing_extensions.Literal["employee"], typing_extensions.Literal["absenceDetails"], typing_extensions.Literal["adminEditUrl"], typing_extensions.Literal["employeeEditUrl"], typing_extensions.Literal["vacancies"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["externalId"]) -> typing.Union[MetaOapg.properties.externalId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["orgId"]) -> typing.Union[MetaOapg.properties.orgId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["startTime"]) -> typing.Union[MetaOapg.properties.startTime, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["endTime"]) -> typing.Union[MetaOapg.properties.endTime, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["numberOfDays"]) -> typing.Union[MetaOapg.properties.numberOfDays, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["isClosed"]) -> typing.Union[MetaOapg.properties.isClosed, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["isDeleted"]) -> typing.Union[MetaOapg.properties.isDeleted, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["approvalStatus"]) -> typing.Union[MetaOapg.properties.approvalStatus, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["notesToApprover"]) -> typing.Union[MetaOapg.properties.notesToApprover, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["adminOnlyNotes"]) -> typing.Union[MetaOapg.properties.adminOnlyNotes, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["totalDuration"]) -> typing.Union[MetaOapg.properties.totalDuration, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["totalDayPortion"]) -> typing.Union[MetaOapg.properties.totalDayPortion, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["employee"]) -> typing.Union['OrgUserEmployeeResponse', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["absenceDetails"]) -> typing.Union[MetaOapg.properties.absenceDetails, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["adminEditUrl"]) -> typing.Union[MetaOapg.properties.adminEditUrl, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["employeeEditUrl"]) -> typing.Union[MetaOapg.properties.employeeEditUrl, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["vacancies"]) -> typing.Union[MetaOapg.properties.vacancies, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id"], typing_extensions.Literal["externalId"], typing_extensions.Literal["orgId"], typing_extensions.Literal["startTime"], typing_extensions.Literal["endTime"], typing_extensions.Literal["numberOfDays"], typing_extensions.Literal["isClosed"], typing_extensions.Literal["isDeleted"], typing_extensions.Literal["approvalStatus"], typing_extensions.Literal["notesToApprover"], typing_extensions.Literal["adminOnlyNotes"], typing_extensions.Literal["totalDuration"], typing_extensions.Literal["totalDayPortion"], typing_extensions.Literal["employee"], typing_extensions.Literal["absenceDetails"], typing_extensions.Literal["adminEditUrl"], typing_extensions.Literal["employeeEditUrl"], typing_extensions.Literal["vacancies"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        id: typing.Union[MetaOapg.properties.id, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        externalId: typing.Union[MetaOapg.properties.externalId, None, str, schemas.Unset] = schemas.unset,
        orgId: typing.Union[MetaOapg.properties.orgId, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        startTime: typing.Union[MetaOapg.properties.startTime, str, datetime, schemas.Unset] = schemas.unset,
        endTime: typing.Union[MetaOapg.properties.endTime, str, datetime, schemas.Unset] = schemas.unset,
        numberOfDays: typing.Union[MetaOapg.properties.numberOfDays, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        isClosed: typing.Union[MetaOapg.properties.isClosed, bool, schemas.Unset] = schemas.unset,
        isDeleted: typing.Union[MetaOapg.properties.isDeleted, bool, schemas.Unset] = schemas.unset,
        approvalStatus: typing.Union[MetaOapg.properties.approvalStatus, None, str, schemas.Unset] = schemas.unset,
        notesToApprover: typing.Union[MetaOapg.properties.notesToApprover, None, str, schemas.Unset] = schemas.unset,
        adminOnlyNotes: typing.Union[MetaOapg.properties.adminOnlyNotes, None, str, schemas.Unset] = schemas.unset,
        totalDuration: typing.Union[MetaOapg.properties.totalDuration, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        totalDayPortion: typing.Union[MetaOapg.properties.totalDayPortion, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        employee: typing.Union['OrgUserEmployeeResponse', schemas.Unset] = schemas.unset,
        absenceDetails: typing.Union[MetaOapg.properties.absenceDetails, list, tuple, None, schemas.Unset] = schemas.unset,
        adminEditUrl: typing.Union[MetaOapg.properties.adminEditUrl, None, str, schemas.Unset] = schemas.unset,
        employeeEditUrl: typing.Union[MetaOapg.properties.employeeEditUrl, None, str, schemas.Unset] = schemas.unset,
        vacancies: typing.Union[MetaOapg.properties.vacancies, list, tuple, None, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'AbsenceResponse':
        return super().__new__(
            cls,
            *_args,
            id=id,
            externalId=externalId,
            orgId=orgId,
            startTime=startTime,
            endTime=endTime,
            numberOfDays=numberOfDays,
            isClosed=isClosed,
            isDeleted=isDeleted,
            approvalStatus=approvalStatus,
            notesToApprover=notesToApprover,
            adminOnlyNotes=adminOnlyNotes,
            totalDuration=totalDuration,
            totalDayPortion=totalDayPortion,
            employee=employee,
            absenceDetails=absenceDetails,
            adminEditUrl=adminEditUrl,
            employeeEditUrl=employeeEditUrl,
            vacancies=vacancies,
            _configuration=_configuration,
        )

from redrover_api.model.absence_detail_response import AbsenceDetailResponse
from redrover_api.model.org_user_employee_response import OrgUserEmployeeResponse
from redrover_api.model.vacancy_response import VacancyResponse
