# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from redrover_api import schemas  # noqa: F401


class SubstituteRequest(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    SubstituteRequest
    """


    class MetaOapg:
        
        class properties:
            replaceExistingRelatedOrgs = schemas.BoolSchema
            
            
            class relatedOrgs(
                schemas.ListBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneTupleMixin
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['SubstituteRelatedOrgRequest']:
                        return SubstituteRelatedOrgRequest
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[list, tuple, None, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'relatedOrgs':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            replaceExistingAttributes = schemas.BoolSchema
            
            
            class attributes(
                schemas.ListBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneTupleMixin
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['SubstituteAttributeRequest']:
                        return SubstituteAttributeRequest
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[list, tuple, None, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'attributes':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def payCode() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
            
            
            class relatedOrgIds(
                schemas.ListBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneTupleMixin
            ):
            
            
                class MetaOapg:
                    items = schemas.Int32Schema
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[list, tuple, None, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'relatedOrgIds':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            id = schemas.Int32Schema
            
            
            class secondaryIdentifier(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'secondaryIdentifier':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class externalId(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'externalId':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class firstName(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'firstName':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class middleName(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'middleName':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class lastName(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'lastName':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class email(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'email':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class notificationEmail(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'notificationEmail':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class dateOfBirth(
                schemas.DateTimeBase,
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    format = 'date-time'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, datetime, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'dateOfBirth':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class address1(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'address1':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class address2(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'address2':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class city(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'city':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class postalCode(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'postalCode':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class badgeNumber(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'badgeNumber':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def state() -> typing.Type['StateEnum']:
                return StateEnum
        
            @staticmethod
            def country() -> typing.Type['CountryEnum']:
                return CountryEnum
            
            
            class phoneNumber(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'phoneNumber':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class active(
                schemas.BoolBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneBoolMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, bool, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'active':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def permissionSet() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
            
            
            class removeFutureAssignmentsOnInactivate(
                schemas.BoolBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneBoolMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, bool, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'removeFutureAssignmentsOnInactivate':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class inviteImmediately(
                schemas.BoolBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneBoolMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, bool, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'inviteImmediately':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            __annotations__ = {
                "replaceExistingRelatedOrgs": replaceExistingRelatedOrgs,
                "relatedOrgs": relatedOrgs,
                "replaceExistingAttributes": replaceExistingAttributes,
                "attributes": attributes,
                "payCode": payCode,
                "relatedOrgIds": relatedOrgIds,
                "id": id,
                "secondaryIdentifier": secondaryIdentifier,
                "externalId": externalId,
                "firstName": firstName,
                "middleName": middleName,
                "lastName": lastName,
                "email": email,
                "notificationEmail": notificationEmail,
                "dateOfBirth": dateOfBirth,
                "address1": address1,
                "address2": address2,
                "city": city,
                "postalCode": postalCode,
                "badgeNumber": badgeNumber,
                "state": state,
                "country": country,
                "phoneNumber": phoneNumber,
                "active": active,
                "permissionSet": permissionSet,
                "removeFutureAssignmentsOnInactivate": removeFutureAssignmentsOnInactivate,
                "inviteImmediately": inviteImmediately,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["replaceExistingRelatedOrgs"]) -> MetaOapg.properties.replaceExistingRelatedOrgs: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["relatedOrgs"]) -> MetaOapg.properties.relatedOrgs: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["replaceExistingAttributes"]) -> MetaOapg.properties.replaceExistingAttributes: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["attributes"]) -> MetaOapg.properties.attributes: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["payCode"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["relatedOrgIds"]) -> MetaOapg.properties.relatedOrgIds: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secondaryIdentifier"]) -> MetaOapg.properties.secondaryIdentifier: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["externalId"]) -> MetaOapg.properties.externalId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["firstName"]) -> MetaOapg.properties.firstName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["middleName"]) -> MetaOapg.properties.middleName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["lastName"]) -> MetaOapg.properties.lastName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["email"]) -> MetaOapg.properties.email: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["notificationEmail"]) -> MetaOapg.properties.notificationEmail: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dateOfBirth"]) -> MetaOapg.properties.dateOfBirth: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["address1"]) -> MetaOapg.properties.address1: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["address2"]) -> MetaOapg.properties.address2: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["city"]) -> MetaOapg.properties.city: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["postalCode"]) -> MetaOapg.properties.postalCode: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["badgeNumber"]) -> MetaOapg.properties.badgeNumber: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["state"]) -> 'StateEnum': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["country"]) -> 'CountryEnum': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["phoneNumber"]) -> MetaOapg.properties.phoneNumber: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["active"]) -> MetaOapg.properties.active: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["permissionSet"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["removeFutureAssignmentsOnInactivate"]) -> MetaOapg.properties.removeFutureAssignmentsOnInactivate: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["inviteImmediately"]) -> MetaOapg.properties.inviteImmediately: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["replaceExistingRelatedOrgs"], typing_extensions.Literal["relatedOrgs"], typing_extensions.Literal["replaceExistingAttributes"], typing_extensions.Literal["attributes"], typing_extensions.Literal["payCode"], typing_extensions.Literal["relatedOrgIds"], typing_extensions.Literal["id"], typing_extensions.Literal["secondaryIdentifier"], typing_extensions.Literal["externalId"], typing_extensions.Literal["firstName"], typing_extensions.Literal["middleName"], typing_extensions.Literal["lastName"], typing_extensions.Literal["email"], typing_extensions.Literal["notificationEmail"], typing_extensions.Literal["dateOfBirth"], typing_extensions.Literal["address1"], typing_extensions.Literal["address2"], typing_extensions.Literal["city"], typing_extensions.Literal["postalCode"], typing_extensions.Literal["badgeNumber"], typing_extensions.Literal["state"], typing_extensions.Literal["country"], typing_extensions.Literal["phoneNumber"], typing_extensions.Literal["active"], typing_extensions.Literal["permissionSet"], typing_extensions.Literal["removeFutureAssignmentsOnInactivate"], typing_extensions.Literal["inviteImmediately"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["replaceExistingRelatedOrgs"]) -> typing.Union[MetaOapg.properties.replaceExistingRelatedOrgs, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["relatedOrgs"]) -> typing.Union[MetaOapg.properties.relatedOrgs, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["replaceExistingAttributes"]) -> typing.Union[MetaOapg.properties.replaceExistingAttributes, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["attributes"]) -> typing.Union[MetaOapg.properties.attributes, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["payCode"]) -> typing.Union['Int32LocatorRequest', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["relatedOrgIds"]) -> typing.Union[MetaOapg.properties.relatedOrgIds, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secondaryIdentifier"]) -> typing.Union[MetaOapg.properties.secondaryIdentifier, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["externalId"]) -> typing.Union[MetaOapg.properties.externalId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["firstName"]) -> typing.Union[MetaOapg.properties.firstName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["middleName"]) -> typing.Union[MetaOapg.properties.middleName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["lastName"]) -> typing.Union[MetaOapg.properties.lastName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["email"]) -> typing.Union[MetaOapg.properties.email, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["notificationEmail"]) -> typing.Union[MetaOapg.properties.notificationEmail, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dateOfBirth"]) -> typing.Union[MetaOapg.properties.dateOfBirth, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["address1"]) -> typing.Union[MetaOapg.properties.address1, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["address2"]) -> typing.Union[MetaOapg.properties.address2, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["city"]) -> typing.Union[MetaOapg.properties.city, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["postalCode"]) -> typing.Union[MetaOapg.properties.postalCode, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["badgeNumber"]) -> typing.Union[MetaOapg.properties.badgeNumber, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["state"]) -> typing.Union['StateEnum', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["country"]) -> typing.Union['CountryEnum', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["phoneNumber"]) -> typing.Union[MetaOapg.properties.phoneNumber, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["active"]) -> typing.Union[MetaOapg.properties.active, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["permissionSet"]) -> typing.Union['Int32LocatorRequest', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["removeFutureAssignmentsOnInactivate"]) -> typing.Union[MetaOapg.properties.removeFutureAssignmentsOnInactivate, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["inviteImmediately"]) -> typing.Union[MetaOapg.properties.inviteImmediately, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["replaceExistingRelatedOrgs"], typing_extensions.Literal["relatedOrgs"], typing_extensions.Literal["replaceExistingAttributes"], typing_extensions.Literal["attributes"], typing_extensions.Literal["payCode"], typing_extensions.Literal["relatedOrgIds"], typing_extensions.Literal["id"], typing_extensions.Literal["secondaryIdentifier"], typing_extensions.Literal["externalId"], typing_extensions.Literal["firstName"], typing_extensions.Literal["middleName"], typing_extensions.Literal["lastName"], typing_extensions.Literal["email"], typing_extensions.Literal["notificationEmail"], typing_extensions.Literal["dateOfBirth"], typing_extensions.Literal["address1"], typing_extensions.Literal["address2"], typing_extensions.Literal["city"], typing_extensions.Literal["postalCode"], typing_extensions.Literal["badgeNumber"], typing_extensions.Literal["state"], typing_extensions.Literal["country"], typing_extensions.Literal["phoneNumber"], typing_extensions.Literal["active"], typing_extensions.Literal["permissionSet"], typing_extensions.Literal["removeFutureAssignmentsOnInactivate"], typing_extensions.Literal["inviteImmediately"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        replaceExistingRelatedOrgs: typing.Union[MetaOapg.properties.replaceExistingRelatedOrgs, bool, schemas.Unset] = schemas.unset,
        relatedOrgs: typing.Union[MetaOapg.properties.relatedOrgs, list, tuple, None, schemas.Unset] = schemas.unset,
        replaceExistingAttributes: typing.Union[MetaOapg.properties.replaceExistingAttributes, bool, schemas.Unset] = schemas.unset,
        attributes: typing.Union[MetaOapg.properties.attributes, list, tuple, None, schemas.Unset] = schemas.unset,
        payCode: typing.Union['Int32LocatorRequest', schemas.Unset] = schemas.unset,
        relatedOrgIds: typing.Union[MetaOapg.properties.relatedOrgIds, list, tuple, None, schemas.Unset] = schemas.unset,
        id: typing.Union[MetaOapg.properties.id, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        secondaryIdentifier: typing.Union[MetaOapg.properties.secondaryIdentifier, None, str, schemas.Unset] = schemas.unset,
        externalId: typing.Union[MetaOapg.properties.externalId, None, str, schemas.Unset] = schemas.unset,
        firstName: typing.Union[MetaOapg.properties.firstName, None, str, schemas.Unset] = schemas.unset,
        middleName: typing.Union[MetaOapg.properties.middleName, None, str, schemas.Unset] = schemas.unset,
        lastName: typing.Union[MetaOapg.properties.lastName, None, str, schemas.Unset] = schemas.unset,
        email: typing.Union[MetaOapg.properties.email, None, str, schemas.Unset] = schemas.unset,
        notificationEmail: typing.Union[MetaOapg.properties.notificationEmail, None, str, schemas.Unset] = schemas.unset,
        dateOfBirth: typing.Union[MetaOapg.properties.dateOfBirth, None, str, datetime, schemas.Unset] = schemas.unset,
        address1: typing.Union[MetaOapg.properties.address1, None, str, schemas.Unset] = schemas.unset,
        address2: typing.Union[MetaOapg.properties.address2, None, str, schemas.Unset] = schemas.unset,
        city: typing.Union[MetaOapg.properties.city, None, str, schemas.Unset] = schemas.unset,
        postalCode: typing.Union[MetaOapg.properties.postalCode, None, str, schemas.Unset] = schemas.unset,
        badgeNumber: typing.Union[MetaOapg.properties.badgeNumber, None, str, schemas.Unset] = schemas.unset,
        state: typing.Union['StateEnum', schemas.Unset] = schemas.unset,
        country: typing.Union['CountryEnum', schemas.Unset] = schemas.unset,
        phoneNumber: typing.Union[MetaOapg.properties.phoneNumber, None, str, schemas.Unset] = schemas.unset,
        active: typing.Union[MetaOapg.properties.active, None, bool, schemas.Unset] = schemas.unset,
        permissionSet: typing.Union['Int32LocatorRequest', schemas.Unset] = schemas.unset,
        removeFutureAssignmentsOnInactivate: typing.Union[MetaOapg.properties.removeFutureAssignmentsOnInactivate, None, bool, schemas.Unset] = schemas.unset,
        inviteImmediately: typing.Union[MetaOapg.properties.inviteImmediately, None, bool, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'SubstituteRequest':
        return super().__new__(
            cls,
            *_args,
            replaceExistingRelatedOrgs=replaceExistingRelatedOrgs,
            relatedOrgs=relatedOrgs,
            replaceExistingAttributes=replaceExistingAttributes,
            attributes=attributes,
            payCode=payCode,
            relatedOrgIds=relatedOrgIds,
            id=id,
            secondaryIdentifier=secondaryIdentifier,
            externalId=externalId,
            firstName=firstName,
            middleName=middleName,
            lastName=lastName,
            email=email,
            notificationEmail=notificationEmail,
            dateOfBirth=dateOfBirth,
            address1=address1,
            address2=address2,
            city=city,
            postalCode=postalCode,
            badgeNumber=badgeNumber,
            state=state,
            country=country,
            phoneNumber=phoneNumber,
            active=active,
            permissionSet=permissionSet,
            removeFutureAssignmentsOnInactivate=removeFutureAssignmentsOnInactivate,
            inviteImmediately=inviteImmediately,
            _configuration=_configuration,
        )

from redrover_api.model.country_enum import CountryEnum
from redrover_api.model.int32_locator_request import Int32LocatorRequest
from redrover_api.model.state_enum import StateEnum
from redrover_api.model.substitute_attribute_request import SubstituteAttributeRequest
from redrover_api.model.substitute_related_org_request import SubstituteRelatedOrgRequest
