# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from redrover_api import schemas  # noqa: F401


class VacancyCreateRequest(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Vacancy Create Request
    """


    class MetaOapg:
        required = {
            "PositionType",
            "Details",
            "Contract",
        }
        
        class properties:
        
            @staticmethod
            def positionType() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
        
            @staticmethod
            def contract() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
            
            
            class details(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['VacancyDetailCreateRequest']:
                        return VacancyDetailCreateRequest
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['VacancyDetailCreateRequest'], typing.List['VacancyDetailCreateRequest']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'details':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'VacancyDetailCreateRequest':
                    return super().__getitem__(i)
        
            @staticmethod
            def location() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
        
            @staticmethod
            def bellSchedule() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
            
            
            class title(
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    min_length = 1
            
            
            class notesToReplacement(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    max_length = 1500
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'notesToReplacement':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class allowSubToAcceptPart(
                schemas.BoolBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneBoolMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, bool, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'allowSubToAcceptPart':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class externalId(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    max_length = 50
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'externalId':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def payCode() -> typing.Type['Int32LocatorRequest']:
                return Int32LocatorRequest
            holdForManualFill = schemas.BoolSchema
            
            
            class administratorComments(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    max_length = 1500
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'administratorComments':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            __annotations__ = {
                "positionType": positionType,
                "contract": contract,
                "details": details,
                "location": location,
                "bellSchedule": bellSchedule,
                "title": title,
                "notesToReplacement": notesToReplacement,
                "allowSubToAcceptPart": allowSubToAcceptPart,
                "externalId": externalId,
                "payCode": payCode,
                "holdForManualFill": holdForManualFill,
                "administratorComments": administratorComments,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["positionType"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["contract"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["details"]) -> MetaOapg.properties.details: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["location"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["bellSchedule"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["title"]) -> MetaOapg.properties.title: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["notesToReplacement"]) -> MetaOapg.properties.notesToReplacement: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["allowSubToAcceptPart"]) -> MetaOapg.properties.allowSubToAcceptPart: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["externalId"]) -> MetaOapg.properties.externalId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["payCode"]) -> 'Int32LocatorRequest': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["holdForManualFill"]) -> MetaOapg.properties.holdForManualFill: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["administratorComments"]) -> MetaOapg.properties.administratorComments: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["positionType"], typing_extensions.Literal["contract"], typing_extensions.Literal["details"], typing_extensions.Literal["location"], typing_extensions.Literal["bellSchedule"], typing_extensions.Literal["title"], typing_extensions.Literal["notesToReplacement"], typing_extensions.Literal["allowSubToAcceptPart"], typing_extensions.Literal["externalId"], typing_extensions.Literal["payCode"], typing_extensions.Literal["holdForManualFill"], typing_extensions.Literal["administratorComments"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["positionType"]) -> typing.Union['Int32LocatorRequest', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["contract"]) -> typing.Union['Int32LocatorRequest', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["details"]) -> typing.Union[MetaOapg.properties.details, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["location"]) -> typing.Union['Int32LocatorRequest', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["bellSchedule"]) -> typing.Union['Int32LocatorRequest', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["title"]) -> typing.Union[MetaOapg.properties.title, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["notesToReplacement"]) -> typing.Union[MetaOapg.properties.notesToReplacement, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["allowSubToAcceptPart"]) -> typing.Union[MetaOapg.properties.allowSubToAcceptPart, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["externalId"]) -> typing.Union[MetaOapg.properties.externalId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["payCode"]) -> typing.Union['Int32LocatorRequest', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["holdForManualFill"]) -> typing.Union[MetaOapg.properties.holdForManualFill, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["administratorComments"]) -> typing.Union[MetaOapg.properties.administratorComments, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["positionType"], typing_extensions.Literal["contract"], typing_extensions.Literal["details"], typing_extensions.Literal["location"], typing_extensions.Literal["bellSchedule"], typing_extensions.Literal["title"], typing_extensions.Literal["notesToReplacement"], typing_extensions.Literal["allowSubToAcceptPart"], typing_extensions.Literal["externalId"], typing_extensions.Literal["payCode"], typing_extensions.Literal["holdForManualFill"], typing_extensions.Literal["administratorComments"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        positionType: typing.Union['Int32LocatorRequest', schemas.Unset] = schemas.unset,
        contract: typing.Union['Int32LocatorRequest', schemas.Unset] = schemas.unset,
        details: typing.Union[MetaOapg.properties.details, list, tuple, schemas.Unset] = schemas.unset,
        location: typing.Union['Int32LocatorRequest', schemas.Unset] = schemas.unset,
        bellSchedule: typing.Union['Int32LocatorRequest', schemas.Unset] = schemas.unset,
        title: typing.Union[MetaOapg.properties.title, str, schemas.Unset] = schemas.unset,
        notesToReplacement: typing.Union[MetaOapg.properties.notesToReplacement, None, str, schemas.Unset] = schemas.unset,
        allowSubToAcceptPart: typing.Union[MetaOapg.properties.allowSubToAcceptPart, None, bool, schemas.Unset] = schemas.unset,
        externalId: typing.Union[MetaOapg.properties.externalId, None, str, schemas.Unset] = schemas.unset,
        payCode: typing.Union['Int32LocatorRequest', schemas.Unset] = schemas.unset,
        holdForManualFill: typing.Union[MetaOapg.properties.holdForManualFill, bool, schemas.Unset] = schemas.unset,
        administratorComments: typing.Union[MetaOapg.properties.administratorComments, None, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'VacancyCreateRequest':
        return super().__new__(
            cls,
            *_args,
            positionType=positionType,
            contract=contract,
            details=details,
            location=location,
            bellSchedule=bellSchedule,
            title=title,
            notesToReplacement=notesToReplacement,
            allowSubToAcceptPart=allowSubToAcceptPart,
            externalId=externalId,
            payCode=payCode,
            holdForManualFill=holdForManualFill,
            administratorComments=administratorComments,
            _configuration=_configuration,
        )

from redrover_api.model.int32_locator_request import Int32LocatorRequest
from redrover_api.model.vacancy_detail_create_request import VacancyDetailCreateRequest
