# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from redrover_api import schemas  # noqa: F401


class VacancyDetailResponse(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Vacancy Detail
    """


    class MetaOapg:
        
        class properties:
            id = schemas.Int64Schema
            
            
            class assignmentId(
                schemas.Int64Base,
                schemas.IntBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneDecimalMixin
            ):
            
            
                class MetaOapg:
                    format = 'int64'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, decimal.Decimal, int, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'assignmentId':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def substitute() -> typing.Type['SimplePerson']:
                return SimplePerson
            
            
            class externalAssignmentNumber(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'externalAssignmentNumber':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class assignmentIsLongTerm(
                schemas.BoolBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneBoolMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, bool, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'assignmentIsLongTerm':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class assignmentNotes(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'assignmentNotes':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def location() -> typing.Type['Int32IdNameClass']:
                return Int32IdNameClass
            start = schemas.DateTimeSchema
            end = schemas.DateTimeSchema
            actualDurationMinutes = schemas.Int32Schema
            
            
            class accountingCodes(
                schemas.ListBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneTupleMixin
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['AccountingCodeAllocationResponse']:
                        return AccountingCodeAllocationResponse
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[list, tuple, None, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'accountingCodes':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            payDuration = schemas.Float64Schema
            
            
            class payUnit(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'payUnit':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def payCode() -> typing.Type['PayCodeResponse']:
                return PayCodeResponse
        
            @staticmethod
            def vacancyReason() -> typing.Type['Int32IdNameClass']:
                return Int32IdNameClass
            verified = schemas.BoolSchema
            
            
            class verifiedAtUtc(
                schemas.DateTimeBase,
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    format = 'date-time'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, datetime, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'verifiedAtUtc':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class verifyComment(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'verifyComment':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def verifiedBy() -> typing.Type['Int32IdNameClass']:
                return Int32IdNameClass
            
            
            class approvalStatus(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'approvalStatus':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def approvalStatusId() -> typing.Type['ApprovalStatusEnum']:
                return ApprovalStatusEnum
            __annotations__ = {
                "id": id,
                "assignmentId": assignmentId,
                "substitute": substitute,
                "externalAssignmentNumber": externalAssignmentNumber,
                "assignmentIsLongTerm": assignmentIsLongTerm,
                "assignmentNotes": assignmentNotes,
                "location": location,
                "start": start,
                "end": end,
                "actualDurationMinutes": actualDurationMinutes,
                "accountingCodes": accountingCodes,
                "payDuration": payDuration,
                "payUnit": payUnit,
                "payCode": payCode,
                "vacancyReason": vacancyReason,
                "verified": verified,
                "verifiedAtUtc": verifiedAtUtc,
                "verifyComment": verifyComment,
                "verifiedBy": verifiedBy,
                "approvalStatus": approvalStatus,
                "approvalStatusId": approvalStatusId,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["assignmentId"]) -> MetaOapg.properties.assignmentId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["substitute"]) -> 'SimplePerson': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["externalAssignmentNumber"]) -> MetaOapg.properties.externalAssignmentNumber: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["assignmentIsLongTerm"]) -> MetaOapg.properties.assignmentIsLongTerm: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["assignmentNotes"]) -> MetaOapg.properties.assignmentNotes: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["location"]) -> 'Int32IdNameClass': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["start"]) -> MetaOapg.properties.start: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["end"]) -> MetaOapg.properties.end: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["actualDurationMinutes"]) -> MetaOapg.properties.actualDurationMinutes: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["accountingCodes"]) -> MetaOapg.properties.accountingCodes: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["payDuration"]) -> MetaOapg.properties.payDuration: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["payUnit"]) -> MetaOapg.properties.payUnit: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["payCode"]) -> 'PayCodeResponse': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["vacancyReason"]) -> 'Int32IdNameClass': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["verified"]) -> MetaOapg.properties.verified: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["verifiedAtUtc"]) -> MetaOapg.properties.verifiedAtUtc: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["verifyComment"]) -> MetaOapg.properties.verifyComment: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["verifiedBy"]) -> 'Int32IdNameClass': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["approvalStatus"]) -> MetaOapg.properties.approvalStatus: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["approvalStatusId"]) -> 'ApprovalStatusEnum': ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id"], typing_extensions.Literal["assignmentId"], typing_extensions.Literal["substitute"], typing_extensions.Literal["externalAssignmentNumber"], typing_extensions.Literal["assignmentIsLongTerm"], typing_extensions.Literal["assignmentNotes"], typing_extensions.Literal["location"], typing_extensions.Literal["start"], typing_extensions.Literal["end"], typing_extensions.Literal["actualDurationMinutes"], typing_extensions.Literal["accountingCodes"], typing_extensions.Literal["payDuration"], typing_extensions.Literal["payUnit"], typing_extensions.Literal["payCode"], typing_extensions.Literal["vacancyReason"], typing_extensions.Literal["verified"], typing_extensions.Literal["verifiedAtUtc"], typing_extensions.Literal["verifyComment"], typing_extensions.Literal["verifiedBy"], typing_extensions.Literal["approvalStatus"], typing_extensions.Literal["approvalStatusId"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["assignmentId"]) -> typing.Union[MetaOapg.properties.assignmentId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["substitute"]) -> typing.Union['SimplePerson', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["externalAssignmentNumber"]) -> typing.Union[MetaOapg.properties.externalAssignmentNumber, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["assignmentIsLongTerm"]) -> typing.Union[MetaOapg.properties.assignmentIsLongTerm, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["assignmentNotes"]) -> typing.Union[MetaOapg.properties.assignmentNotes, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["location"]) -> typing.Union['Int32IdNameClass', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["start"]) -> typing.Union[MetaOapg.properties.start, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["end"]) -> typing.Union[MetaOapg.properties.end, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["actualDurationMinutes"]) -> typing.Union[MetaOapg.properties.actualDurationMinutes, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["accountingCodes"]) -> typing.Union[MetaOapg.properties.accountingCodes, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["payDuration"]) -> typing.Union[MetaOapg.properties.payDuration, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["payUnit"]) -> typing.Union[MetaOapg.properties.payUnit, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["payCode"]) -> typing.Union['PayCodeResponse', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["vacancyReason"]) -> typing.Union['Int32IdNameClass', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["verified"]) -> typing.Union[MetaOapg.properties.verified, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["verifiedAtUtc"]) -> typing.Union[MetaOapg.properties.verifiedAtUtc, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["verifyComment"]) -> typing.Union[MetaOapg.properties.verifyComment, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["verifiedBy"]) -> typing.Union['Int32IdNameClass', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["approvalStatus"]) -> typing.Union[MetaOapg.properties.approvalStatus, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["approvalStatusId"]) -> typing.Union['ApprovalStatusEnum', schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id"], typing_extensions.Literal["assignmentId"], typing_extensions.Literal["substitute"], typing_extensions.Literal["externalAssignmentNumber"], typing_extensions.Literal["assignmentIsLongTerm"], typing_extensions.Literal["assignmentNotes"], typing_extensions.Literal["location"], typing_extensions.Literal["start"], typing_extensions.Literal["end"], typing_extensions.Literal["actualDurationMinutes"], typing_extensions.Literal["accountingCodes"], typing_extensions.Literal["payDuration"], typing_extensions.Literal["payUnit"], typing_extensions.Literal["payCode"], typing_extensions.Literal["vacancyReason"], typing_extensions.Literal["verified"], typing_extensions.Literal["verifiedAtUtc"], typing_extensions.Literal["verifyComment"], typing_extensions.Literal["verifiedBy"], typing_extensions.Literal["approvalStatus"], typing_extensions.Literal["approvalStatusId"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        id: typing.Union[MetaOapg.properties.id, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        assignmentId: typing.Union[MetaOapg.properties.assignmentId, None, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        substitute: typing.Union['SimplePerson', schemas.Unset] = schemas.unset,
        externalAssignmentNumber: typing.Union[MetaOapg.properties.externalAssignmentNumber, None, str, schemas.Unset] = schemas.unset,
        assignmentIsLongTerm: typing.Union[MetaOapg.properties.assignmentIsLongTerm, None, bool, schemas.Unset] = schemas.unset,
        assignmentNotes: typing.Union[MetaOapg.properties.assignmentNotes, None, str, schemas.Unset] = schemas.unset,
        location: typing.Union['Int32IdNameClass', schemas.Unset] = schemas.unset,
        start: typing.Union[MetaOapg.properties.start, str, datetime, schemas.Unset] = schemas.unset,
        end: typing.Union[MetaOapg.properties.end, str, datetime, schemas.Unset] = schemas.unset,
        actualDurationMinutes: typing.Union[MetaOapg.properties.actualDurationMinutes, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        accountingCodes: typing.Union[MetaOapg.properties.accountingCodes, list, tuple, None, schemas.Unset] = schemas.unset,
        payDuration: typing.Union[MetaOapg.properties.payDuration, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        payUnit: typing.Union[MetaOapg.properties.payUnit, None, str, schemas.Unset] = schemas.unset,
        payCode: typing.Union['PayCodeResponse', schemas.Unset] = schemas.unset,
        vacancyReason: typing.Union['Int32IdNameClass', schemas.Unset] = schemas.unset,
        verified: typing.Union[MetaOapg.properties.verified, bool, schemas.Unset] = schemas.unset,
        verifiedAtUtc: typing.Union[MetaOapg.properties.verifiedAtUtc, None, str, datetime, schemas.Unset] = schemas.unset,
        verifyComment: typing.Union[MetaOapg.properties.verifyComment, None, str, schemas.Unset] = schemas.unset,
        verifiedBy: typing.Union['Int32IdNameClass', schemas.Unset] = schemas.unset,
        approvalStatus: typing.Union[MetaOapg.properties.approvalStatus, None, str, schemas.Unset] = schemas.unset,
        approvalStatusId: typing.Union['ApprovalStatusEnum', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'VacancyDetailResponse':
        return super().__new__(
            cls,
            *_args,
            id=id,
            assignmentId=assignmentId,
            substitute=substitute,
            externalAssignmentNumber=externalAssignmentNumber,
            assignmentIsLongTerm=assignmentIsLongTerm,
            assignmentNotes=assignmentNotes,
            location=location,
            start=start,
            end=end,
            actualDurationMinutes=actualDurationMinutes,
            accountingCodes=accountingCodes,
            payDuration=payDuration,
            payUnit=payUnit,
            payCode=payCode,
            vacancyReason=vacancyReason,
            verified=verified,
            verifiedAtUtc=verifiedAtUtc,
            verifyComment=verifyComment,
            verifiedBy=verifiedBy,
            approvalStatus=approvalStatus,
            approvalStatusId=approvalStatusId,
            _configuration=_configuration,
        )

from redrover_api.model.accounting_code_allocation_response import AccountingCodeAllocationResponse
from redrover_api.model.approval_status_enum import ApprovalStatusEnum
from redrover_api.model.int32_id_name_class import Int32IdNameClass
from redrover_api.model.pay_code_response import PayCodeResponse
from redrover_api.model.simple_person import SimplePerson
