# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.  # Authentication The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.  This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.  Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.  # API Information ## Api Key Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.  You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.  ## Identifier Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from redrover_api import schemas  # noqa: F401


class VacancyResponse(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Vacancy
    """


    class MetaOapg:
        
        class properties:
        
            @staticmethod
            def position() -> typing.Type['Int32IdNameClass']:
                return Int32IdNameClass
        
            @staticmethod
            def contract() -> typing.Type['Int32IdNameClass']:
                return Int32IdNameClass
        
            @staticmethod
            def approvalStatus() -> typing.Type['ApprovalStatusEnum']:
                return ApprovalStatusEnum
            isLongTerm = schemas.BoolSchema
            
            
            class notesToReplacement(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'notesToReplacement':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class adminOnlyNotes(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'adminOnlyNotes':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class administratorComments(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'administratorComments':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class allowSubToAcceptPart(
                schemas.BoolBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneBoolMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, bool, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'allowSubToAcceptPart':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class details(
                schemas.ListBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneTupleMixin
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['VacancyDetailResponse']:
                        return VacancyDetailResponse
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[list, tuple, None, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'details':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class holdForManualFillUntilUtc(
                schemas.DateTimeBase,
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    format = 'date-time'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, datetime, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'holdForManualFillUntilUtc':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class holdForAutoAssignUntilUtc(
                schemas.DateTimeBase,
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    format = 'date-time'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, datetime, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'holdForAutoAssignUntilUtc':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def fillStatus() -> typing.Type['FillStatusEnum']:
                return FillStatusEnum
            
            
            class absenceId(
                schemas.Int64Base,
                schemas.IntBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneDecimalMixin
            ):
            
            
                class MetaOapg:
                    format = 'int64'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, decimal.Decimal, int, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'absenceId':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class adminEditUrl(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'adminEditUrl':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            id = schemas.Int64Schema
            
            
            class externalId(
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'externalId':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            __annotations__ = {
                "position": position,
                "contract": contract,
                "approvalStatus": approvalStatus,
                "isLongTerm": isLongTerm,
                "notesToReplacement": notesToReplacement,
                "adminOnlyNotes": adminOnlyNotes,
                "administratorComments": administratorComments,
                "allowSubToAcceptPart": allowSubToAcceptPart,
                "details": details,
                "holdForManualFillUntilUtc": holdForManualFillUntilUtc,
                "holdForAutoAssignUntilUtc": holdForAutoAssignUntilUtc,
                "fillStatus": fillStatus,
                "absenceId": absenceId,
                "adminEditUrl": adminEditUrl,
                "id": id,
                "externalId": externalId,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["position"]) -> 'Int32IdNameClass': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["contract"]) -> 'Int32IdNameClass': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["approvalStatus"]) -> 'ApprovalStatusEnum': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["isLongTerm"]) -> MetaOapg.properties.isLongTerm: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["notesToReplacement"]) -> MetaOapg.properties.notesToReplacement: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["adminOnlyNotes"]) -> MetaOapg.properties.adminOnlyNotes: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["administratorComments"]) -> MetaOapg.properties.administratorComments: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["allowSubToAcceptPart"]) -> MetaOapg.properties.allowSubToAcceptPart: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["details"]) -> MetaOapg.properties.details: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["holdForManualFillUntilUtc"]) -> MetaOapg.properties.holdForManualFillUntilUtc: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["holdForAutoAssignUntilUtc"]) -> MetaOapg.properties.holdForAutoAssignUntilUtc: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fillStatus"]) -> 'FillStatusEnum': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["absenceId"]) -> MetaOapg.properties.absenceId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["adminEditUrl"]) -> MetaOapg.properties.adminEditUrl: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["externalId"]) -> MetaOapg.properties.externalId: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["position"], typing_extensions.Literal["contract"], typing_extensions.Literal["approvalStatus"], typing_extensions.Literal["isLongTerm"], typing_extensions.Literal["notesToReplacement"], typing_extensions.Literal["adminOnlyNotes"], typing_extensions.Literal["administratorComments"], typing_extensions.Literal["allowSubToAcceptPart"], typing_extensions.Literal["details"], typing_extensions.Literal["holdForManualFillUntilUtc"], typing_extensions.Literal["holdForAutoAssignUntilUtc"], typing_extensions.Literal["fillStatus"], typing_extensions.Literal["absenceId"], typing_extensions.Literal["adminEditUrl"], typing_extensions.Literal["id"], typing_extensions.Literal["externalId"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["position"]) -> typing.Union['Int32IdNameClass', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["contract"]) -> typing.Union['Int32IdNameClass', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["approvalStatus"]) -> typing.Union['ApprovalStatusEnum', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["isLongTerm"]) -> typing.Union[MetaOapg.properties.isLongTerm, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["notesToReplacement"]) -> typing.Union[MetaOapg.properties.notesToReplacement, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["adminOnlyNotes"]) -> typing.Union[MetaOapg.properties.adminOnlyNotes, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["administratorComments"]) -> typing.Union[MetaOapg.properties.administratorComments, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["allowSubToAcceptPart"]) -> typing.Union[MetaOapg.properties.allowSubToAcceptPart, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["details"]) -> typing.Union[MetaOapg.properties.details, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["holdForManualFillUntilUtc"]) -> typing.Union[MetaOapg.properties.holdForManualFillUntilUtc, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["holdForAutoAssignUntilUtc"]) -> typing.Union[MetaOapg.properties.holdForAutoAssignUntilUtc, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fillStatus"]) -> typing.Union['FillStatusEnum', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["absenceId"]) -> typing.Union[MetaOapg.properties.absenceId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["adminEditUrl"]) -> typing.Union[MetaOapg.properties.adminEditUrl, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["externalId"]) -> typing.Union[MetaOapg.properties.externalId, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["position"], typing_extensions.Literal["contract"], typing_extensions.Literal["approvalStatus"], typing_extensions.Literal["isLongTerm"], typing_extensions.Literal["notesToReplacement"], typing_extensions.Literal["adminOnlyNotes"], typing_extensions.Literal["administratorComments"], typing_extensions.Literal["allowSubToAcceptPart"], typing_extensions.Literal["details"], typing_extensions.Literal["holdForManualFillUntilUtc"], typing_extensions.Literal["holdForAutoAssignUntilUtc"], typing_extensions.Literal["fillStatus"], typing_extensions.Literal["absenceId"], typing_extensions.Literal["adminEditUrl"], typing_extensions.Literal["id"], typing_extensions.Literal["externalId"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        position: typing.Union['Int32IdNameClass', schemas.Unset] = schemas.unset,
        contract: typing.Union['Int32IdNameClass', schemas.Unset] = schemas.unset,
        approvalStatus: typing.Union['ApprovalStatusEnum', schemas.Unset] = schemas.unset,
        isLongTerm: typing.Union[MetaOapg.properties.isLongTerm, bool, schemas.Unset] = schemas.unset,
        notesToReplacement: typing.Union[MetaOapg.properties.notesToReplacement, None, str, schemas.Unset] = schemas.unset,
        adminOnlyNotes: typing.Union[MetaOapg.properties.adminOnlyNotes, None, str, schemas.Unset] = schemas.unset,
        administratorComments: typing.Union[MetaOapg.properties.administratorComments, None, str, schemas.Unset] = schemas.unset,
        allowSubToAcceptPart: typing.Union[MetaOapg.properties.allowSubToAcceptPart, None, bool, schemas.Unset] = schemas.unset,
        details: typing.Union[MetaOapg.properties.details, list, tuple, None, schemas.Unset] = schemas.unset,
        holdForManualFillUntilUtc: typing.Union[MetaOapg.properties.holdForManualFillUntilUtc, None, str, datetime, schemas.Unset] = schemas.unset,
        holdForAutoAssignUntilUtc: typing.Union[MetaOapg.properties.holdForAutoAssignUntilUtc, None, str, datetime, schemas.Unset] = schemas.unset,
        fillStatus: typing.Union['FillStatusEnum', schemas.Unset] = schemas.unset,
        absenceId: typing.Union[MetaOapg.properties.absenceId, None, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        adminEditUrl: typing.Union[MetaOapg.properties.adminEditUrl, None, str, schemas.Unset] = schemas.unset,
        id: typing.Union[MetaOapg.properties.id, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        externalId: typing.Union[MetaOapg.properties.externalId, None, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'VacancyResponse':
        return super().__new__(
            cls,
            *_args,
            position=position,
            contract=contract,
            approvalStatus=approvalStatus,
            isLongTerm=isLongTerm,
            notesToReplacement=notesToReplacement,
            adminOnlyNotes=adminOnlyNotes,
            administratorComments=administratorComments,
            allowSubToAcceptPart=allowSubToAcceptPart,
            details=details,
            holdForManualFillUntilUtc=holdForManualFillUntilUtc,
            holdForAutoAssignUntilUtc=holdForAutoAssignUntilUtc,
            fillStatus=fillStatus,
            absenceId=absenceId,
            adminEditUrl=adminEditUrl,
            id=id,
            externalId=externalId,
            _configuration=_configuration,
        )

from redrover_api.model.approval_status_enum import ApprovalStatusEnum
from redrover_api.model.fill_status_enum import FillStatusEnum
from redrover_api.model.int32_id_name_class import Int32IdNameClass
from redrover_api.model.vacancy_detail_response import VacancyDetailResponse
